#include "Cua.hpp"
//#include "CuaIO.hpp"
#include<iostream>

using namespace std;

//Pre: c=C i c1 i c2 són buides
void distribucio(Cua<pair<int,int> > & c, 
		 Cua<pair<int,int> > & c1, Cua<pair<int,int> > & c2){
int e1=0;
int e2=0;

/*{Inv: c1 i c2 són una distribució justa dels elements C que no són a c
        e1 és el temps d'espera a c1
        e2 és el temps d'espera a c2
 */

while (not c.es_buida()){
  if (e1 > e2) {
    c2.demanar_torn(c.primer());
    e2+=c.primer().second;
  }
  else {
    c1.demanar_torn(c.primer());
    e1+=c.primer().second;
  }
  c.avancar();  
 }
//Post: c1 i c2 són una distribució justa dels elements de C
}



void llegir_cua(Cua<pair<int,int> > & c){
  int x,y;
  cin >> x >> y;
  while (x!=0 or y!=0){
    c.demanar_torn(make_pair(x,y));
    cin >> x >> y;
  }
}

void escriure_cua(Cua<pair<int,int> > & c){
  while (not c.es_buida()){
    cout << c.primer().first << " " << c.primer().second << endl;
    c.avancar();
  }
}


int main() {
  Cua<pair<int,int> > c,c1,c2;
  cout << "Introdueix la cua:"<< endl;
  llegir_cua(c);
  distribucio(c,c1,c2);
  cout << "Primera cua:"<< endl;
  escriure_cua(c1);
  cout << endl << "Segona cua:"<< endl;
  escriure_cua(c2);
}
