#ifndef CUA_IO
#define CUA_IO

#include "utils.PRO2"
#include  "Cua.hpp"

template <class T> 
void llegir_cua(Cua<T> &c, T marca)
{
  T n;
  cin >> n;
  while (n != marca){
    c.demanar_torn(n);
    cin >> n;
  }
}

template <class T> 
void escriure_cua(const Cua<T> &c)
{
  cout << "[Primer] "<< endl;
  Cua<T> copia(c);
  while(!copia.es_buida()){
    cout << copia.primer() << endl;
    copia.avancar();
  }
  cout << "[Ultim]"<<endl;
}

#endif
